(function fun() {
  var sendEvent = function sendEvent(category, details, useLS, ignoreQueue) {
    if (useLS) {
      var current = JSON.parse(localStorage.swpending || '[]');

      current.push({
        category: category,
        details: details
      });

      localStorage.swpending = JSON.stringify(current);
      return;
    }

    $.ajax({
      type: 'POST',
      url: 'https://test2.reco.statwolf.com/cdp/recordEvent',
      data: JSON.stringify({
        "api-key": "0bf3292f9e8d4405aa79b06be24c2f81",
        evtCategory: category,
        evtDetails: JSON.stringify(details),
        cookies: document.cookie,
        userAgent: navigator.userAgent,
        pagePath: location.href
      }),
      dataType: 'json',
      headers: {
        "Content-Type": "application/json"
      }
    });

    if (ignoreQueue) {
      return;
    }

    var queue = JSON.parse(localStorage.swpending || '[]');
    if (queue.length > 0) {
      queue.forEach(function (qitem) {
        sendEvent(qitem.category, qitem.details, undefined, true);
      });

      localStorage.swpending = JSON.stringify([]);
    }
  };

  var jqwaiter = setInterval(function () {
    if (typeof $ != 'undefined') {
      clearInterval(jqwaiter);
    }

    sendEvent('pageview', {});

    $(document).on("click", ".statwolf-recommendations-wrapper .swiper-container .swiper-slide .product", function () {
      var pid = $(this).attr("data-pid");

      sendEvent('reco-click', {
        sku: pid
      }, true);
    });

    $(document).on("click", "button.add-to-cart", function () {
      sendEvent('add-to-cart', {});
    });

    $(document).on("click", "button.js-open-reserve-in-store-modal", function () {
      sendEvent('reserve-in-store', {});
    });

    $(document).on("click", ".add-to-wishlist-row", function () {
      sendEvent("add-to-wishlist", {});
    });

    setInterval(function () {
      $(".statwolf-recommendations-wrapper .swiper-container .swiper-slide .product").each(function () {
        if ($(this).attr("viewed") == "true") {
          return;
        }

        var pid = $(this).data("pid");

        var top_of_element = $(this).offset().top;
        var bottom_of_element = $(this).offset().top + $(this).outerHeight();
        var bottom_of_screen = $(window).scrollTop() + $(window).innerHeight();
        var top_of_screen = $(window).scrollTop();

        if (bottom_of_screen > top_of_element && top_of_screen < bottom_of_element) {
          var left_of_element = $(this).offset().left;
          var right_of_element = $(this).offset().left + $(this).outerWidth();

          var left_of_carousel = $(".statwolf-recommendations-wrapper").offset().left;
          var right_of_carousel = $(".statwolf-recommendations-wrapper").offset().left + $(".statwolf-recommendations-wrapper").outerWidth();

          if (left_of_element >= left_of_carousel && right_of_element <= right_of_carousel + 50) {
            $(this).attr("viewed", "true");
            sendEvent('reco-impression', {
              sku: pid
            });
          }
        }
      });
    }, 250);
  }, 100);
})();